package com.memorynotfound.xml.jdom;

import org.jdom2.DocType;
import org.jdom2.Document;
import org.jdom2.JDOMException;
import org.jdom2.input.SAXBuilder;
import org.jdom2.input.sax.XMLReaders;

import java.io.IOException;
import java.io.InputStream;

public class ValidateXmlDtdJdom {

    public static void main(String... args) throws JDOMException, IOException {

        // read file from classpath
        InputStream invalid = ValidateXmlDtdJdom.class.getResourceAsStream("/invalid.xml");
        InputStream valid = ValidateXmlDtdJdom.class.getResourceAsStream("/valid.xml");

        // create builder
        SAXBuilder builder = new SAXBuilder(XMLReaders.DTDVALIDATING);
        Document validDocument = builder.build(valid);
        

        // print metadata doc type
        DocType docType = validDocument.getDocType();
        System.out.println("Public ID: " + docType.getPublicID());
        System.out.println("System ID: " + docType.getSystemID());

        // throws an exception while validating against DTD schema
        //Document invalidDocument = builder.build(invalid);
    }
}
